#ifndef _GRAYH
#define _GRAYH

#define Gray_vram_adress (*(Gray_sc_cpv_)Gray_SC0135)
typedef char* (*Gray_sc_cpv_)(void);
const unsigned int Gray_SC0135[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0135 };

typedef enum { FALSE, TRUE } Bool;
typedef enum { GRAY_TRANSPARENT = -1, GRAY_WHITE, GRAY_BLACK, GRAY_XOR, GRAY_CHECKER, GRAY_LIGHT, GRAY_DARK, GRAY_INVERTED, GRAY_CHECKER_GRAY } Gray_Colour;

struct GrayScale {
	Bool Initialised;
	int Time;

	struct DisplayDriverBuffers {
		char* Dark;
		char* Light;

	} DD;

	struct VRAMBuffers {
		char* Dark;
		char* Light;

	} VRAM;

} Gray;

void Gray_Init(void);	//Initialises the buffers
int Gray_Start(void);	//Start the gray engine
int Gray_Stop(void);	//Pause the gray engine
int Gray_Toggle(void);	//Toggle the gray engine
void Gray_PowerOffCalc(Bool logo);	//Turns off calculator
void Gray_Copy_Buffer(char fromBuffer[1024], char toBuffer[1024]);	//Copy one buffer to another
void Gray_Swap_Buffers(void);	//Swap two buffers around
void Gray_Display_DD(void);		//Display the DisplayDriver buffers to the display
void Gray_Delay_ASM(int instructions);		//Create delay by looping. Instructions * 4
void Gray_Display_DD_ASM(char* buffer);		//Display a buffer to the screen
void Gray_Pixel(int x, int y, Gray_Colour colour);							//Draw a gray pixel
void Gray_Vertical_Line(int x, int y1, int y2, Gray_Colour colour);			//Draw a gray vertical line
void Gray_Horizontal_Line(int y, int x1, int x2, Gray_Colour colour);		//Draw a gray horizontal line
void Gray_Rectangle(int x1, int y1, int x2, int y2, Gray_Colour colour);	//Draw a gray Rectangle
void Gray_BMP_Load(unsigned char* bmp, int x, int y, int width, int height, int fullWidthInBytes);
void Gray_Mono_VRAM_To_Gray(void(*function)(void));

#endif





//tempBufferDark = Gray.VRAM.Dark;
//tempBufferLight = Gray.VRAM.Light;
//for (y = 0; y < 64; y++) {
//	for (x = 0; x < 16; x++) {
//		if (x < 8)
//			*tempBufferDark++ = 0xFF;
//		else
//			*tempBufferDark++ = 0;
//		if (x < 4 || (x > 7 && x < 12))
//			*tempBufferLight++ = 0xFF;
//		else
//			*tempBufferLight++ = 0;
//	}
//}
//Gray_Horizontal_Line(20, 0, 127, GRAY_INVERTED);
//Gray_Horizontal_Line(40, 0, 127, GRAY_XOR);