#include "keybios.h"
#define KEY_ENCODE
//#define KEY_DECODE

#ifdef KEY_ENCODE
int KeyEncode(int kcode1, int kcode2) {
	unsigned int key;
	unsigned short KeyCodes[6][9] = {
		KEY_CTRL_NOP,	 KEY_CTRL_NOP,   KEY_CTRL_NOP,	KEY_CTRL_NOP, KEY_CHAR_STORE, KEY_CHAR_TAN,	KEY_CTRL_RIGHT,  KEY_CTRL_UP,	 KEY_CTRL_F6,
		KEY_CTRL_EXE,	 KEY_CHAR_MINUS, KEY_CHAR_DIV,	KEY_CTRL_NOP, KEY_CHAR_COMMA, KEY_CHAR_COS,	KEY_CTRL_DOWN,   KEY_CTRL_LEFT,  KEY_CTRL_F5,
		KEY_CHAR_PMINUS, KEY_CHAR_PLUS,  KEY_CHAR_MULT,	KEY_CTRL_DEL, KEY_CHAR_RPAR,  KEY_CHAR_SIN,	KEY_CTRL_EXIT,   KEY_CTRL_MENU,  KEY_CTRL_F4,
		KEY_CHAR_EXP,	 KEY_CHAR_3,	 KEY_CHAR_6,	KEY_CHAR_9,   KEY_CHAR_LPAR,  KEY_CHAR_LN,	KEY_CHAR_POW,	 KEY_CTRL_VARS,  KEY_CTRL_F3,
		KEY_CHAR_DP,	 KEY_CHAR_2,	 KEY_CHAR_5,	KEY_CHAR_8,   KEY_CTRL_FD,	  KEY_CHAR_LOG,	KEY_CHAR_SQUARE, KEY_CTRL_OPTN,  KEY_CTRL_F2,
		KEY_CHAR_0,		 KEY_CHAR_1,	 KEY_CHAR_4,	KEY_CHAR_7,   KEY_CHAR_FRAC,  KEY_CTRL_XTT,	KEY_CTRL_ALPHA,  KEY_CTRL_SHIFT, KEY_CTRL_F1
	};

	if (kcode1 < 2 || kcode2 < 2 || kcode1 > 7 || kcode2 > 10)
		return kcode1 == 1 && kcode2 == 1 ? KEY_CTRL_AC : KEY_CTRL_NOP;

	return KeyCodes[kcode1 - 2][kcode2 - 2];
}
#endif // KEYENCODE

#ifdef KEY_DECODE
void KeyDecode(int key, int* kcode1, int* kcode2, char* modifier) {
	short kcode;
	char KeyCodes[208] = {
		-1, 26
	};

	if (key < 13)
		kcode = 0;
	else
		kcode = KeyCodes[key - 13];
	*kcode1 = kcode / 10;
	*kcode2 = kcode - *kcode1 * 10;
}
#endif // KEYDECODE


/*
#define KEY_CTRL_NOP        0x00
#define KEY_CHAR_CR         0x0d
#define KEY_CHAR_STORE      0x0e
#define KEY_CHAR_EXP        0x0f
#define KEY_CHAR_SPACE      0x20
#define KEY_CHAR_DQUATE     0x22
#define KEY_CHAR_LPAR       0x28
#define KEY_CHAR_RPAR       0x29
#define KEY_CHAR_COMMA      0x2c
#define KEY_CHAR_DP         0x2e
#define KEY_CHAR_0          0x30
#define KEY_CHAR_1          0x31
#define KEY_CHAR_2          0x32
#define KEY_CHAR_3          0x33
#define KEY_CHAR_4          0x34
#define KEY_CHAR_5          0x35
#define KEY_CHAR_6          0x36
#define KEY_CHAR_7          0x37
#define KEY_CHAR_8          0x38
#define KEY_CHAR_9          0x39
#define KEY_CHAR_EQUAL      0x3d
#define KEY_CHAR_A          0x41
#define KEY_CHAR_B          0x42
#define KEY_CHAR_C          0x43
#define KEY_CHAR_D          0x44
#define KEY_CHAR_E          0x45
#define KEY_CHAR_F          0x46
#define KEY_CHAR_G          0x47
#define KEY_CHAR_H          0x48
#define KEY_CHAR_I          0x49
#define KEY_CHAR_J          0x4a
#define KEY_CHAR_K          0x4b
#define KEY_CHAR_L          0x4c
#define KEY_CHAR_M          0x4d
#define KEY_CHAR_N          0x4e
#define KEY_CHAR_O          0x4f
#define KEY_CHAR_P          0x50
#define KEY_CHAR_Q          0x51
#define KEY_CHAR_R          0x52
#define KEY_CHAR_S          0x53
#define KEY_CHAR_T          0x54
#define KEY_CHAR_U          0x55
#define KEY_CHAR_V          0x56
#define KEY_CHAR_W          0x57
#define KEY_CHAR_X          0x58
#define KEY_CHAR_Y          0x59
#define KEY_CHAR_Z          0x5a
#define KEY_CHAR_LBRCKT     0x5b
#define KEY_CHAR_RBRCKT     0x5d
#define KEY_CHAR_LBRACE     0x7b
#define KEY_CHAR_RBRACE     0x7d
#define KEY_CHAR_SIN        0x81
#define KEY_CHAR_COS        0x82
#define KEY_CHAR_TAN        0x83
#define KEY_CHAR_LN         0x85
#define KEY_CHAR_ROOT       0x86
#define KEY_CHAR_PMINUS     0x87
#define KEY_CHAR_PLUS       0x89
#define KEY_CHAR_SQUARE     0x8b
#define KEY_CHAR_ASIN       0x91
#define KEY_CHAR_ACOS       0x92
#define KEY_CHAR_ATAN       0x93
#define KEY_CHAR_LOG        0x95
#define KEY_CHAR_CUBEROOT   0x96
#define KEY_CHAR_MINUS      0x99
#define KEY_CHAR_RECIP      0x9b
#define KEY_CHAR_EXPN       0xa5
#define KEY_CHAR_POW        0xa8
#define KEY_CHAR_MULT       0xa9
#define KEY_CHAR_EXPN10     0xb5
#define KEY_CHAR_POWROOT    0xb8
#define KEY_CHAR_DIV        0xb9
#define KEY_CHAR_FRAC       0xbb
#define KEY_CHAR_ANS        0xc0
#define KEY_CHAR_VALR       0xcd
#define KEY_CHAR_THETA      0xce
#define KEY_CHAR_PI         0xd0

#define KEY_CTRL_XTT        0x7531
#define KEY_CTRL_EXIT       0x7532
#define KEY_CTRL_MENU       0x7533
#define KEY_CTRL_EXE        0x7534
#define KEY_CTRL_SHIFT      0x7536
#define KEY_CTRL_ALPHA      0x7537
#define KEY_CTRL_OPTN       0x7538
#define KEY_CTRL_F1         0x7539
#define KEY_CTRL_F2         0x753A
#define KEY_CTRL_F3         0x753B
#define KEY_CTRL_F4         0x753C
#define KEY_CTRL_F5         0x753D
#define KEY_CTRL_F6         0x753E
#define KEY_CTRL_AC         0x753F
#define KEY_CTRL_VARS       0x7540
#define KEY_CTRL_UP         0x7541
#define KEY_CTRL_LEFT       0x7544
#define KEY_CTRL_RIGHT      0x7545
#define KEY_CTRL_DOWN       0x7547
#define KEY_CTRL_DEL        0x7548
#define KEY_CTRL_FRACCNVRT  0x7549
#define KEY_CTRL_PRGM       0x754B
#define KEY_CTRL_QUIT       0x754C
#define KEY_CTRL_INS        0x7551
#define KEY_CTRL_PASTE      0x7554
#define KEY_CTRL_SETUP      0x7555
#define KEY_CTRL_FD         0x755E
#define KEY_CTRL_CLIP       0x7562
#define KEY_CTRL_PAGEUP     0x7564
#define KEY_CTRL_PAGEDOWN   0x7565
#define KEY_CTRL_MIXEDFRAC  0x7566
#define KEY_CTRL_CAPTURE    0x7567
#define	KEY_CTRL_RESERVE1	0x756C
#define	KEY_CTRL_RESERVE2	0x756D
#define	KEY_CTRL_RESERVE3	0x756E
#define KEY_CTRL_CATALOG    0x7594

#define KEY_CHAR_IMGNRY     0x7f50
#define KEY_CHAR_LIST       0x7f51
#define KEY_CHAR_MAT        0x7f40
#define KEY_CHAR_ANGLE      0x7f54
*/